---
title: Une histoire de pizzas, étape 2
template: game
---

<a href="../une-histoire-de-pizzas-2.html">Lire l’article associé</a>

<div id="app">
    <div class="board">
        <!-- Ça, ça ne change pas -->
        <div v-for="y in size" :key="y" class="board-line">
            <div v-for="x in size" :key="x" class="board-cell">
            </div>
        </div>

        <!--
            On itère sur les entités (objets) du store pour les ajouter dans le
            HTML. Le truc important ici est la fonction "entityPosition" qui va
            retourner les dimensions et la position en CSS de l'entité pour que
            le navigateur l'affiche au bon endroit.
        -->
        <div
          v-for="(entity, id) in store"
          :key="id"
          :class="['board-cell-entity', id]"
          :style="entityPosition(entity)"
        >
            <!-- Si l'entité a un composant "label", on l’ajoute au HTML. -->
            <div v-if="entity.label" class="entity-label">
                {{ entity.label }}
            </div>
        </div>
    </div>
</div>

<script>
    const BOARD_SIZE = 6;

    // Cette valeur correspond à la variable --cell-size en CSS.
    const CSS_CELL_SIZE = 128;

    // L'ensemble de nos entités avec leurs composants est stocké dans un gros
    // objet JavaScript.
    let gameStore = {
        // L'identifiant de l'entité est une clé (meiko) de l'objet JS. On lui
        // associe un ensemble de composants (label, size et position)
        meiko: {
            label: 'Meiko',
            size: { width: 1, height: 1 },
            position: { x: 3, y: 2 },
        },

        // Et on fait la même chose avec toutes les entités de notre jeu
        mozza: {
            label: 'Mozzarella',
            size: { width: 1, height: 1 },
            position: { x: 1, y: 3 },
        },
        tomato: {
            label: 'Sauce tomate',
            size: { width: 1, height: 1 },
            position: { x: 2, y: 5 },
        },
        dough: {
            label: 'Pâte à pizza',
            size: { width: 1, height: 1 },
            position: { x: 5, y: 3 },
        },

        oven: {
            label: 'Four',
            size: { width: 2, height: 1 },
            position: { x: 1, y: 0 },
        },
        hatch: {
            label: 'Passe-plat',
            size: { width: 1, height: 1 },
            position: { x: 5, y: 0 },
        },
        fridge: {
            label: 'Frigo',
            size: { width: 2, height: 2 },
            position: { x: 0, y: 2 },
        },
        workplan: {
            label: 'Plan de travail',
            size: { width: 1, height: 2 },
            position: { x: 5, y: 2 },
        },
        shelf: {
            label: 'Étagère',
            size: { width: 4, height: 1 },
            position: { x: 2, y: 5 },
        },
    };

    const app = new Vue({
        el: '#app',
        data: {
            size: BOARD_SIZE,
            // on ajoute le store à "data" pour pouvoir y accéder dans le html
            store: gameStore,
        },

        methods: {
            // entityPosition retourne la position de l'entité en CSS.
            entityPosition(entity) {
                if (entity.size == null || entity.position == null) {
                    // Si l'entité ne possède pas de taille ou de position,
                    // cela signifie qu'on ne peut pas l'afficher : on ne
                    // retourne donc rien.
                    return {};
                }

                return {
                    // on multiplie la taille de l'entité par la taille d'une
                    // cellule pour obtenir sa taille en CSS (et on n'oublie
                    // pas de préciser l'unité sinon ça marche pas !!)
                    width: (entity.size.width * CSS_CELL_SIZE) + 'px',
                    height: (entity.size.height * CSS_CELL_SIZE) + 'px',

                    // et pareil pour obtenir sa position
                    top: (entity.position.y * CSS_CELL_SIZE) + 'px',
                    left: (entity.position.x * CSS_CELL_SIZE) + 'px',
                };
            },
        },
    });
</script>

<style type="text/css">
    #app {
        --cell-size: 128px;

        --color-floor: #fff;
        --color-floor-border: #ccc;
    }

    /*
       Ça c'est important pour pas se prendre la tête sur les dimensions mais
       je ne rentre pas dans le détail du pourquoi du comment.
    */
    * {
        box-sizing: border-box;
    }

    .board-line {
        display: flex;
    }

    .board-cell {
        width: var(--cell-size);
        height: var(--cell-size);

        background-color: var(--color-floor);
        border: 1px solid var(--color-floor-border);
    }

    /*
       Les entités ont une position absolue *au sein* du tableau, donc on
       précise le nécessaire pour éviter qu'elles ne volent n'importe où à
       l'écran, et surtout pas en dehors du cadre de jeu.
    */
    .board {
        position: relative;
    }
    .board-cell-entity {
        position: absolute;
    }

    /* Puis on colorie nos entités pour les rendre plus visibles à l'écran */
    .board-cell-entity.oven { background-color: #333; }
    .board-cell-entity.fridge { background-color: #666; }
    .board-cell-entity.workplan { background-color: #783f04; }
    .board-cell-entity.shelf { background-color: #000; }
    .board-cell-entity.hatch { background-color: #cf2a27; }

    .board-cell-entity .entity-label { color: #fff; }
    .board-cell-entity.shelf .entity-label { text-align: right; }

    /*
       Certaines entités peuvent être superposées à d'autres (la pâte, la mozza
       et la sauce tomate). On leur met un z-index pour être sûr qu'elles se
       trouveront au-dessus.
    */
    .board-cell-entity.dough,
    .board-cell-entity.mozza,
    .board-cell-entity.tomato {
        z-index: 10;

        background-color: green;
    }

    /*
       Meiko a droit à un style un peu différent mais ça change pas grand-chose
       à la logique : on le colorie aussi !
    */
    .board-cell-entity.meiko {
        border: 2px solid green;
    }
    .board-cell-entity.meiko .entity-label {
        color: initial;
    }
</style>
